#include "Attack.h"
#include "IA/utils.h"

Attack::Attack(int id, ATTACK_TYPE type, float range, float damage, int manaCost, Ogre::SceneNode* proyectil, Shape* shape, Ogre::Vector3 direction)
        : GameActor(id,proyectil,GameActor::Attack, shape,0)
{
	mType=type;
	mRange=range;
	mDamage=damage;
	mManaCost=manaCost;
	mIsActive=false;
        mDirection=direction;
        mDirection.normalise();
}

Attack::~Attack(void)
{
}

Attack::ATTACK_TYPE Attack::getAttackType() {
	return mType;
}

float Attack::getRange() {
	return mRange;
}

float Attack::getDamage() {
	return mDamage;
}

int Attack::getManaCost() {
	return mManaCost;
}


void Attack::executeAttack() {
	mIsActive=true;
        mTravesedDistance=0;
}

void Attack::update(float elapsedTime) {
    if (mTravesedDistance>=mRange) {
        finalizeAttack();
    }
}


void Attack::finalizeAttack() {
	mIsActive=false;
        getNode()->setVisible(false,true);
}

bool Attack::isActive() {
	return mIsActive;
}

void Attack::setOwner(GameActor* owner) {
	mOwner=owner;
}

GameActor* Attack::getOwner() {
	return mOwner;
}

void Attack::advance(float vy) {
    mTravesedDistance+=vy;
    Ogre::Vector3 finalPos=getNode()->getPosition()+mDirection*vy;
    getNode()->setPosition(finalPos);
}