#include "Escenario.h"
#include "GestorEscenario.h"

Escenario::Escenario(char*  nombre, char*  file)
{
	mNombre=nombre;
	strcpy(mCfgFile,file);
	//mListaElementos=new std::vector(100);
}

Escenario::~Escenario(void)
{
}

//Aade o quita un objeto que haya sido colocado en el escenario
void Escenario::addElement(Elemento *e) {
	mListaElementos.push_back(e);
}

void Escenario::removeElement(Elemento *e) {
	if (mListaElementos.empty()) {
		return;
	}
	int i=0;
	Elemento *aux=(Elemento*)mListaElementos.back();
	std::vector<Elemento*> listaAux;//=new std::vector(100);
	while (!mListaElementos.empty()) {
		aux=(Elemento*)mListaElementos.back();
		mListaElementos.pop_back();
		if (aux->mPosicion!=e->mPosicion) {
			listaAux.push_back(aux);
		}
		else {
			delete aux;
		}
	}	
	mListaElementos=listaAux;
}

//establece la ubicacion en la que aparecera el jugador
void Escenario::setInitialPosition(Ogre::Vector3 pos) {
	mPosInicial=pos;
}

//establece el terreno (suelo) y cielo del escenario a partir de los nombres de las imagenes
void Escenario::setTerreno(char* ){}
void Escenario::setCielo(char* ){}

//cambia la ambientacion visual
void Escenario::setNiebla(Ogre::FogMode tipo,Ogre::ColourValue color,float densidad,float comienzo, float fin){
	mTipoNiebla=tipo;
	mColorNiebla=color;
	mDensidadNiebla=densidad;
	mComienzoNiebla=comienzo;
	mFinNiebla=fin;
}
void Escenario::setLuz(Ogre::Light* luz, Ogre::ColourValue ambient){
	mLuz=luz;
	mAmbientLight=ambient;
}

bool Escenario::saveEscenario() {
	FILE* f;
	try {
		f=fopen(mNombre,"w");
		//fichero de configuracion
		fprintf(f,"%s\n",mCfgFile);

		//luces y niebla
		fprintf(f,"Diff - %f - %f - %f\n",mLuz->getDiffuseColour().r,mLuz->getDiffuseColour().g,mLuz->getDiffuseColour().b);
		fprintf(f,"Spec - %f - %f - %f\n",mLuz->getSpecularColour().r,mLuz->getSpecularColour().g,mLuz->getSpecularColour().b);
		fprintf(f,"Ambi - %f - %f - %f\n",mAmbientLight.r,mAmbientLight.g,mAmbientLight.b);

		fprintf(f,"Fog - %f - %f - %f\n",mColorNiebla.r,mColorNiebla.g,mColorNiebla.b);
		fprintf(f,"Fog - %d - %f - %f - %f\n",(int)mTipoNiebla,mDensidadNiebla,mComienzoNiebla,mFinNiebla);

		//elementos del escenario
		int tam=(int)mListaElementos.size();
		fprintf(f,"%d\n",tam);
		Elemento *aux=0;
		for (int i=0;i<tam;i++) {
			aux=(Elemento*)mListaElementos.back();
			mListaElementos.pop_back();
			fprintf(f,"%d - %f - %f - %f\n",aux->mTipo,aux->mPosicion.x,aux->mPosicion.y,aux->mPosicion.z);
		}
		fclose(f);
		return true;
	}
	catch (std::exception& e) {
		fclose(f);
		return false;
	}
}

bool Escenario::loadEscenario() {
	FILE* f;
	try {
		GestorEscenario* gestor=GestorEscenario::getSingletonPtr();
		f=fopen(mNombre,"r");
		//fichero de configuracion
		fscanf(f,"%s\n",mCfgFile);

		//luces y niebla
		float r=0;
		float g=0;
		float b=0;
		fscanf(f,"Diff - %f - %f - %f\n",&r,&g,&b);
		Ogre::ColourValue diff(r,g,b);
		fscanf(f,"Spec - %f - %f - %f\n",&r,&g,&b);
		Ogre::ColourValue spec(r,g,b);
		fscanf(f,"Ambi - %f - %f - %f\n",&r,&g,&b);
		Ogre::ColourValue ambi(r,g,b);
		gestor->setLuz(diff,spec,ambi);

		int tipoNiebla=0;
		fscanf(f,"Fog - %f - %f - %f\n",&r,&g,&b);
		Ogre::ColourValue fog(r,g,b);
		fscanf(f,"Fog - %d - %f - %f - %f\n",&tipoNiebla,&r,&g,&b);
		gestor->setNiebla((Ogre::FogMode)tipoNiebla,fog,r,g,b);

		//elementos del escenario
		int tam=0;
		fscanf(f,"%d\n",&tam);
		Elemento *aux=0;
		int tipo=0;
		float x=0;
		float y=0;
		float z=0;
		for (int i=0;i<tam;i++) {
			fscanf(f,"%d - %f - %f - %f\n",&tipo,&x,&y,&z);
			gestor->addElement((GestorEscenario::tipoElemento)tipo,Ogre::Vector3(x,y,z));
		}
		fclose(f);
		return true;
	}
	catch (std::exception& e) {
		fclose(f);
		return false;
	}
}