/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
//#include "EventType.h"
#include <Ogre.h>

#include "Creature.h"
#include "Attack.h"

//! Clase encargada de notificar las colisiones de los ataques.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Evento que representa la colisión de un ataque contra una criatura. 
 *  Este evento le llega a la clase EstadoPrueba para que lo gestione como deba
 *  (en principio al recibir esto lanzará un Evt_Atacado para la criatura dañada y destruirá el ataque) 
 */

class Evt_AplicarAtaque : public GardeGames::Event
{
public:
	static char const * const gkName;
	Evt_AplicarAtaque(Attack* ataque, GameActor* atacado);
	~Evt_AplicarAtaque(void);

	
	GameActor *mAtacado;
	Attack* mAtaque;
};
