/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
#include <Ogre.h>

#include "GameActor.h"

//! Clase encargada de transmitir los impactos de los ataques.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Evento que representa el daño que sufrirá una criatura a causa de un ataque. 
 *  Una vez colisionan, la clase EstadoJugando dispara este evento,
 *  que es recibido por el listener de la criatura afectada para que se inflinja daño, actualizar su barra de vida y quizás morir.
 */

class Evt_Atacado : public GardeGames::Event
{
public:
	static char const * const gkName;
	Evt_Atacado(GameActor *atacante, GameActor *atacado, float damage);
	~Evt_Atacado(void);

	GameActor *mAtacante;
	GameActor *mAtacado;
	float mDamage;
};
