/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
#include <Ogre.h>

#include "GameActor.h"
#include "Attack.h"
#include "Creature.h"

//! Clase encargada de transmitir la intención de atacar de las criaturas.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Evento que representa el intento de ataque de una criatura. 
 *  Se dispara en la vista de la criatura, lo recibe la clase EstadoJugando y,
 *  si no hay objeciones, se crea un ataque y una vista para el mismo y se comienza a actualizar.
 */

class Evt_Atacar : public GardeGames::Event
{
public:
	static char const * const gkName;
	Evt_Atacar(Creature *atacante, Attack::ATTACK_TYPE type, Ogre::Vector3 direction, float height);
	~Evt_Atacar(void);

	Creature* mAtacante;
	Attack::ATTACK_TYPE mType;
        Ogre::Vector3 mDirection;
        float mHeight;
};