/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "GardeGames/GardeGames.h"
#include <Ogre.h>

#include "Creature.h"

//! Clase encargada de avisar de la muerte de una criatura.


/**
 *  @author Miguel Garde Vallés
 *  @date 9-03-2012
 *
 *  Evento disparado por las vistas de las criaturas cuando éstas mueren.
 *  El evento es recogido por las demás criaturas para dejar de tenerla en cuenta,
 *  en definitiva, para que nadie la referencie cuando se elimine completamente del juego.
 */

class Evt_Muerto : public GardeGames::Event
{
public:
	static char const * const gkName;
	Evt_Muerto(Creature *elemento);
	~Evt_Muerto(void);

	Creature *mElemento;
};
