#include "HumanView.h"
#include "HumanViewListener.h"
#include "Evt_Mover.h"
#include "Evt_Sonido.h"
#include "Evt_Camara.h"
#include "Evt_Atacar.h"
#include "Evt_Atacado.h"
#include "Evt_ComenzarAtaque.h"

#define CAM_HEIGHT 7
#define RUN_SPEED 170           // character running speed in units per second
#define TURN_SPEED 60      // character turning in degrees per millisecond
#define RANGE_ATTACK_DELAY 1900
#define MELEE_ATTACK_DELAY 900

HumanView::HumanView(Creature *elfa,                                                
                                                Ogre::PanelOverlayElement *lifeBar,
						GardeGames::GameAction *accionAlante,
						GardeGames::GameAction *accionAtras,
						GardeGames::GameAction *accionIzda,
						GardeGames::GameAction *accionDcha,
						GardeGames::GameAction *accionRatonMovido,
						GardeGames::GameAction *accionGolpea,
						GardeGames::GameAction *accionLanzaRayo,
						GardeGames::GameAction *accionElfa,
						GardeGames::GameAction *accionLobo,
						GardeGames::GameAction *accionCiervo,
						Ogre::Camera* cam
						)
{
        mJugador=mElfa=elfa;    
        mLifeBar=lifeBar;
       // mLobo=lobo;
        //mCiervo=ciervo;
        //mLobo->getNode()->setVisible(false);
        //mCiervo->getNode()->setVisible(false);

	mEstadoActual=IDLE;

	mAccionAlante=accionAlante;
	mAccionAtras=accionAtras;
	mAccionIzda=accionIzda;
	mAccionDcha=accionDcha;
	mAccionRatonMovido=accionRatonMovido;
	mAccionGolpea=accionGolpea;
	mAccionLanzaRayo=accionLanzaRayo;
	mAccionTransElfa=accionElfa;
	mAccionTransLobo=accionLobo;
	mAccionTransCiervo=accionCiervo;
	//mRayo=rayo;
	mTiempoRayo=0;


	// create a pivot at roughly the character's shoulder
	mCameraPivot = cam->getSceneManager()->getRootSceneNode()->createChildSceneNode();
	// this is where the camera should be soon, and it spins around the pivot
	mCameraGoal = mCameraPivot->createChildSceneNode(Ogre::Vector3(0, 10, 35));
	// this is where the camera actually is
	mCameraNode = cam->getSceneManager()->getRootSceneNode()->createChildSceneNode();
	mCameraNode->setPosition(mCameraPivot->getPosition() + mCameraGoal->getPosition());

	mCameraPivot->setFixedYawAxis(true);
	mCameraGoal->setFixedYawAxis(true);
	mCameraNode->setFixedYawAxis(true);
	mCameraNode->attachObject(cam);

	mPivotPitch = 0;

	GardeGames::EventListenerPtr listener ( new HumanViewListener(this) );
	
	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();

	evtMgr->addListener( listener, GardeGames::EventType(Evt_Mover::gkName) );
	evtMgr->addListener( listener, GardeGames::EventType(Evt_Sonido::gkName) );
	evtMgr->addListener( listener, GardeGames::EventType(Evt_Atacado::gkName) );
}

HumanView::~HumanView(void)
{
}


void HumanView::VOnUpdate( int deltaMilliseconds ) {
	
	mJugador->update(deltaMilliseconds);
        
        if (mAccionTransElfa->isPressed() && mJugador!=mElfa) {
            //cambiarForma(mElfa);
            return;
        }
        /*if (mAccionTransCiervo->isPressed() && mJugador!=mCiervo) {
            //cambiarForma(mCiervo);
            return;
        }
        if (mAccionTransLobo->isPressed() && mJugador!=mLobo) {
            //cambiarForma(mLobo);
            return;
        }*/
        
	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
        //evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(mJugador,Ogre::Vector3(0.1,0,0.1))));

	if (mAccionRatonMovido->isPressed()) {
		evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Camara()));
	}
        

	updateCamera(deltaMilliseconds);
        
        if (!mJugador->isAlive()) {
            mJugador->setState(Creature::DIE,false);
            //if (mJugador->getHeightOverFloor()>-5){
            //    mJugador->setHeight(mJugador->getHeightOverFloor()-0.1);
            //}
            return;
        }
        //printf("tiempo animacion: %f\n",auxT);
	/*if (mTiempoRayo>0) {
		mTiempoRayo-=deltaMilliseconds;
	}
	else {
		//mRayoPivot->setVisible(false);
	}*/	

		//-------------------------\\

	if (mEstadoActual==FACING_ATTACK1) {
		Ogre::Real giro=atacar(deltaMilliseconds);
		Ogre::Real yawAtSpeed = 60;
		// turn as much as we can, but not more than we need to
		if (giro < 0) {
			giro = std::min<Ogre::Real>(0, std::max<Ogre::Real>(giro, -yawAtSpeed)); //yawToGoal = Math::Clamp<Real>(yawToGoal, yawAtSpeed, 0);
		}
		else if (giro > 0) {
			giro = std::max<Ogre::Real>(0, std::min<Ogre::Real>(giro, yawAtSpeed)); //yawToGoal = Math::Clamp<Real>(yawToGoal, 0, yawAtSpeed);
		}
		if (abs(giro)<=1) {
			//mTiempoRayo=0.5*1000;
			//evtMgr->queueEvent(GardeGames::EventPtr( new Evt_ComenzarAtaque(mJugador,mJugador->getAttack1())));
			mEstadoActual=ATTACKING1;
//			mJugador->mInputHelper.reset();
//			mJugador->mAnimatedCharacter->playAnimation(103, Critter::Enums::NO_ANIMATION, Critter::Enums::StockAnimationID_Idle, Critter::Enums::StockAnimationID_Idle, true);
//			mJugador->mAnimatedCharacter->setInput(mJugador->mInputHelper);
		}
		else {
			Ogre::Vector3 mov(-giro,0,0);
			evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(mJugador,mov)));
		}
		return;
	}
	else if (mEstadoActual==FACING_ATTACK2) {
		Ogre::Real giro=atacar(deltaMilliseconds);
		Ogre::Real yawAtSpeed = 60;
		// turn as much as we can, but not more than we need to
		if (giro < 0) {
			giro = std::min<Ogre::Real>(0, std::max<Ogre::Real>(giro, -yawAtSpeed)); //yawToGoal = Math::Clamp<Real>(yawToGoal, yawAtSpeed, 0);
		}
		else if (giro > 0) {
			giro = std::max<Ogre::Real>(0, std::min<Ogre::Real>(giro, yawAtSpeed)); //yawToGoal = Math::Clamp<Real>(yawToGoal, 0, yawAtSpeed);
		}
		if (abs(giro)<=5) {
			//mTiempoRayo=0.5*1000;
//			evtMgr->queueEvent(GardeGames::EventPtr( new Evt_ComenzarAtaque(mJugador,mJugador->getAttack2())));
			mEstadoActual=ATTACKING2;
//			mJugador->mInputHelper.reset();
//			mJugador->mAnimatedCharacter->playAnimation(103, Critter::Enums::NO_ANIMATION, Critter::Enums::StockAnimationID_Idle, Critter::Enums::StockAnimationID_Idle, true);
//			mJugador->mAnimatedCharacter->setInput(mJugador->mInputHelper);
		}
		else {
			Ogre::Vector3 mov(-giro,0,0);
			evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(mJugador,mov)));
		}
		return;
	}
	else if (mEstadoActual==ATTACKING1) {
            mTiempoRayo+=deltaMilliseconds;
            mElfa->setState(Creature::ATTACK1,false);
            if (mTiempoRayo==RANGE_ATTACK_DELAY/2) {
                Ogre::Vector3 direccion=mCameraPivot->getPosition()-mCameraNode->getPosition();
                evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Atacar(mJugador,mJugador->getAttack2(),direccion,9)));
            }
            if (mTiempoRayo>=RANGE_ATTACK_DELAY) {
                mTiempoRayo=0;
		mEstadoActual=IDLE;
            }
	}
        else if (mEstadoActual==ATTACKING2) {
            mTiempoRayo+=deltaMilliseconds;
            mElfa->setState(Creature::ATTACK2,false);
            if (mTiempoRayo==MELEE_ATTACK_DELAY/2) {
                Ogre::Vector3 direccion=mCameraPivot->getPosition()-mCameraNode->getPosition();
                evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Atacar(mJugador,mJugador->getAttack1(),direccion,3)));
            }
            if (mTiempoRayo>=MELEE_ATTACK_DELAY) {
                mTiempoRayo=0;
		mEstadoActual=IDLE;
            }
	}
	//si estado == IDLE
	Ogre::Vector3 mKeyDirection = Ogre::Vector3::ZERO;   
	if (mAccionAlante->isPressed()) {		
		mKeyDirection.z=-1;
	}
	if (mAccionAtras->isPressed()) {
		mKeyDirection.z=1;
	}
	if (mAccionIzda->isPressed()) {		
		mKeyDirection.x=-1;		
	}
	if (mAccionDcha->isPressed()) {
		mKeyDirection.x=1;
	}

	if (mAccionGolpea->isPressed() && mEstadoActual==IDLE) {
                mEstadoActual=FACING_ATTACK1;
            //Sound3D* sonido = mJugador->getSound(Creature::RUN)//new Sound3D("goblinEnter.wav");       
            //evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Sonido(mJugador,Evt_Sonido::Walk,mJugador->getSound(Creature::ATTACK1),false)));
            //evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Sonido(mJugador,Evt_Sonido::None)));
	}

	if (mAccionLanzaRayo->isPressed() && mEstadoActual==IDLE) {
		mEstadoActual=FACING_ATTACK2;
	}

	Ogre::Vector3 mGoalDirection = Ogre::Vector3::ZERO;   // we will calculate this
	if (mKeyDirection != Ogre::Vector3::ZERO)
	{
		// calculate actually goal direction in world based on player's key directions
		mGoalDirection += mKeyDirection.z * mCameraNode->getOrientation().zAxis();
		mGoalDirection += mKeyDirection.x * mCameraNode->getOrientation().xAxis();
		mGoalDirection.y = 0;
		mGoalDirection.normalise();

		Ogre::Quaternion toGoal = mJugador->getOrientation().zAxis().getRotationTo(mGoalDirection);

		// calculate how much the character has to turn to face goal direction
		Ogre::Real yawToGoal = toGoal.getYaw().valueDegrees();
		// this is how much the character CAN turn this frame
		Ogre::Real yawAtSpeed = 127;
		Ogre::Real moveAtSpeed = 327;
		// turn as much as we can, but not more than we need to
		if (yawToGoal < 0) {
			yawToGoal = std::min<Ogre::Real>(0, std::max<Ogre::Real>(yawToGoal, -yawAtSpeed)); //yawToGoal = Math::Clamp<Real>(yawToGoal, yawAtSpeed, 0);
		}
		else if (yawToGoal > 0) {
			yawToGoal = std::max<Ogre::Real>(0, std::min<Ogre::Real>(yawToGoal, yawAtSpeed)); //yawToGoal = Math::Clamp<Real>(yawToGoal, 0, yawAtSpeed);
		}
			
		Ogre::Vector3 mov(0,0,0);
		mov.x=-yawToGoal;
		mov.z=moveAtSpeed;
		
		evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(mJugador,mov)));
                Sound3D* sonido = mJugador->getSound(Creature::RUN);//new Sound3D("goblinEnter.wav");       
                evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Sonido(mJugador,Evt_Sonido::Walk,sonido,false)));
	}
        else { //se queda quieto
            evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Sonido(mJugador,Evt_Sonido::None)));
        }
        
        //ponemos la posicion de todos los nodos en la del actual
	Ogre::Vector3 posAux=mJugador->getPosition();
        mElfa->getNode()->setPosition(posAux);
        //mCiervo->getNode()->setPosition(posAux);
        //mLobo->getNode()->setPosition(posAux);

}

void HumanView::cambiarForma(Creature* nuevaForma) {
    //guardamos posicion y orientacion de la forma actual
    Ogre::Vector3 posAux=mJugador->getPosition();
    Ogre::Quaternion orAux=mJugador->getOrientation();
    //hacemos desaparecer la forma actual
    //mJugador->getNode()->setVisible(false);
    //cambiamos la capsula de fisica
    nuevaForma->getNode()->setPosition(posAux.x,posAux.y+nuevaForma->getHeightOverFloor()-mJugador->getHeightOverFloor(),posAux.z);
    nuevaForma->getNode()->setOrientation(orAux);
    nuevaForma->setBody(mJugador->getBody());
    nuevaForma->synchronizeBody();
    //hacemos aparecer la nueva forma
    nuevaForma->getNode()->setVisible(true);
    //cambiamos el puntero
    mJugador=nuevaForma;
}

Ogre::Real HumanView::atacar(Ogre::Real deltaTime) {
	//comprobamos si ya esta mirando al frente
	Ogre::Vector3 mGoalDirection = Ogre::Vector3::ZERO;   // we will calculate this
	// calculate actually goal direction in world based on player's key directions
	mGoalDirection += - mCameraNode->getOrientation().zAxis();
	mGoalDirection += 0;
	mGoalDirection.y = 0;
	mGoalDirection.normalise();
	Ogre::Quaternion toGoal = mJugador->getOrientation().zAxis().getRotationTo(mGoalDirection);
	// calculate how much the character has to turn to face goal direction
	return toGoal.getYaw().valueDegrees();
}

Creature* HumanView::getPlayer() {
    return mJugador;
}

void HumanView::adjustCamHeight(Ogre::Real newHeight) {
    while (mCameraGoal->getPosition().y<newHeight) {
        updateCameraGoal(0, 3, 0);
    }
}

Ogre::Vector3 HumanView::getCamPosition() {
    return mCameraNode->getPosition();
}
        
Ogre::Vector3 HumanView::getPivotPosition() {    
    return mCameraPivot->getPosition();
}


void HumanView::updateCamera(Ogre::Real deltaTime)
	{
		/*
		mCameraNode->lookAt(mJugador->getPosition(), Ogre::Node::TS_WORLD);
		*/

		// place the camera pivot roughly at the character's shoulder
		mCameraPivot->setPosition(mJugador->getPosition() + Ogre::Vector3::UNIT_Y * CAM_HEIGHT);
		// move the camera smoothly to the goal
		Ogre::Vector3 goalOffset = mCameraGoal->_getDerivedPosition() - mCameraNode->getPosition();
		mCameraNode->translate(goalOffset*9.0f/50);
		//mCameraNode->setPosition(mCameraGoal->_getDerivedPosition());
		// always look at the pivot
		mCameraNode->lookAt(mCameraPivot->_getDerivedPosition(), Ogre::Node::TS_WORLD);
	}

void HumanView::updateCameraGoal(Ogre::Real deltaYaw, Ogre::Real deltaPitch, Ogre::Real deltaZoom)
	{
		mCameraPivot->yaw(Ogre::Degree(deltaYaw), Ogre::Node::TS_WORLD);

		// bound the pitch
		if (!(mPivotPitch + deltaPitch > 40 && deltaPitch > 0) &&
			!(mPivotPitch + deltaPitch < -40 && deltaPitch < 0))
		{
			mCameraPivot->pitch(Ogre::Degree(deltaPitch), Ogre::Node::TS_LOCAL);
			mPivotPitch += deltaPitch;
		}
		
		//zoom de la camara
/*		Ogre::Real dist = mCameraGoal->_getDerivedPosition().distance(mCameraPivot->_getDerivedPosition());
		Ogre::Real distChange = deltaZoom * dist;

		// bound the zoom
		if (!(dist + distChange < 8 && distChange < 0) &&
			!(dist + distChange > 25 && distChange > 0))
		{
			mCameraGoal->translate(0, 0, distChange, Ogre::Node::TS_LOCAL);
		}
*/
	}