/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */



#pragma once

#include "../GardeGames/GardeGames.h"
#include <Ogre.h>
#include "../Creature.h"
#include "../StaticActor.h"
#include "../IA/navigationMesh.h"
//#include "SteeringBehaviors.h"




/**
 *  @author Hector Agustin Lana
 *  @date 14-01-2012
 *
 *  Esta clase modela una vista de inteligencia artificial.
 * 
 *  
 */


class SteeringBehaviors;

const double MIN_TIME_BETWEEN_ATTACKS=1;
const double MIN_TIME_BETWEEN_DAMAGE=2;
const double MIN_TARGET_DISTANCE=10;

class AIView :public GardeGames::IGameView
{
public:

	AIView(Creature *criatura, Ogre::Billboard* lifeBar);
	~AIView(void);

        
	// funciones heredadas (aunque ahora no uso ninguna)
	GameViewType VGetType(){return IGameView::GameView_AI;};
	GameViewId VGetId() const {return 0;};

	virtual void VOnUpdate( int deltaMilliseconds )=0;
	
	double desiredVelocityX;
	double desiredVelocityY;
	Creature *mCreature;

	Creature *getCreature();

	Creature *getTarget();

	StaticActor *getClosestObstacle();

	double timeSinceLastFrame;
        
        double timeSinceLastAttack;
        
        bool facingTarget();

	double getTimeSinceLastFrame();
        
        double getTimeSinceLastAttack();
        
        bool canAttack();
        
        bool nearTarget();
        
        bool isAttacking();

	navigationMesh::PointPath _path; 
        
         Ogre::Vector3 arrivingPoint;
         
          Ogre::Vector3 getArrivingPoint();
        
          void setNavigationMesh(navigationMesh* navigationMesh);
        
        // Búsqueda de caminos
        navigationMesh* _navigationMesh;
        navigationMesh::PointPath::iterator _pathIt;
        Cell* _currentCell;
        bool _pathActive;
        
        bool Attacking;
        
        
        

	Ogre::Vector2 getVelocity();
	void setVelocityX(double velocityX);
        void setVelocityY(double velocityY);

	Ogre::Vector2 addForce(Ogre::Vector2 steeringForce);
	
	Ogre::Vector2 velocity;

	
	double steeringForceX;
	double steeringForceY;

	StaticActor* closestObstacle;
	Creature* target; 

        Ogre::Billboard* mLifeBar;

	bool isClosestObstacle();
        
        bool isClosestTarget();
        
        void setTimeSinceLastAttack(double time);
        
        bool canDamage();
};
