/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "AIViewDragonListener.h"
#include "AIViewDragon.h"
#include "AIView.h"
#include "../Evt_Mover.h"
#include "../Evt_Visto.h"
#include "../Evt_Sonido.h"
#include "../Evt_Muerto.h"
#include "../Evt_Atacado.h"
#include "../Creature.h"

AIViewDragonListener::AIViewDragonListener(AIViewDragon * aiv) :AIViewListener(aiv)
{
	mAIViewDragon=aiv;
}

AIViewDragonListener::~AIViewDragonListener(void)
{
}

bool AIViewDragonListener::HandleEvent( GardeGames::Event & evento ) {

	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
        std::vector<GameActor*> obstaculosVistos;
	if (stricmp(evento.getType().getStr(),Evt_Visto::gkName)==0) 
	  { //si veo a alguien empiezo a vagar
		 Evt_Visto evt=dynamic_cast<Evt_Visto &>(evento);
		 if (evt.mCreature->getId()!=mAIView->getCreature()->getId()) 
		   { //si no es para nosotros nos vamos
			  return false;
		   }
              
		 while (!evt.mResultado.empty())
		 {

			  GameActor * actualActor=evt.mResultado.back();  
			  int tipo =actualActor->getType();
                          
			   if (tipo<=1)//si no es un obstaculo 
			   {  
   
                                  Creature *actualCreature=static_cast<Creature*>(actualActor);
                                  
                                  if (actualCreature->isAlive())
                                      
                                  {
                                  
                                  
			  	     if (!mAIViewDragon->GetFSM()->isInState(*SeekingDragon::Instance())) //si estaba persiguiendo
				      {

					     mAIView->target=static_cast<Creature*>(actualActor);
					     //si no estaba huyendo que huya	
			 
                                                                                 
                                                   evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Sonido(mAIView->mCreature,Evt_Sonido::Howl,mAIView->mCreature->getSound(Creature::ATTACK1),false)));  
					  	   mAIViewDragon->GetFSM()->ChangeState(SeekingDragon::Instance());
					       
				       }
                                  else //comprobar distancia
                                    {
                                       //si la presa vista esta mas cerca de la que persigo voy a por esa
                                       Ogre::Vector2 posActualCreature =Ogre::Vector2(mAIView->target->getPosition().x, mAIView->target->getPosition().z);
				       double ActualCreatureDistance=posActualCreature.squaredDistance(Ogre::Vector2(mAIView->getCreature()->getPosition().x,mAIView->getCreature()->getPosition().z));
                                       Creature *viewCreature=static_cast<Creature*>(actualActor);
                                       Ogre::Vector2 posViewCreature =Ogre::Vector2(viewCreature->getPosition().x, viewCreature->getPosition().z);
                                       double ViewCreatureDistance=posViewCreature.squaredDistance(Ogre::Vector2(mAIView->getCreature()->getPosition().x,mAIView->getCreature()->getPosition().z));
                                       if (ViewCreatureDistance<ActualCreatureDistance)
                                        {
                                           mAIView->target=viewCreature;
                                        }
                                       
                                     }
                                  }
                                   
                                  return false;
			     }
                           else if (tipo==GameActor::House)
                          {
                              obstaculosVistos.push_back(actualActor);
                          }
                          else
                          {
                               obstaculosVistos.push_back(actualActor);
                          }
			  

			    evt.mResultado.pop_back();

		    }  
                 
                    //ACTUALIZAR LA PERCEPCIÓN DE OBSTACULOS 
                    UpdateObstaclesPerception(obstaculosVistos); 
                 
	   }
        
        else if (stricmp(evento.getType().getStr(),Evt_Atacado::gkName)==0)  
         {
            Evt_Atacado evt=dynamic_cast<Evt_Atacado &>(evento);
            if (evt.mAtacado->getId()!=mAIView->getCreature()->getId()) 
            { //si no es para nosotros nos vamos
                return false;
            }
            printf("\nDragon atacado");
            mAIView->mCreature->getDamage(evt.mDamage*3000);
            
            Ogre::Real ratio = (Ogre::Real)mAIView->mCreature->mActualHealth / (Ogre::Real)mAIView->mCreature->mMaxHealth;
    
            if (ratio < 0.0f)
                ratio = 0.0f;

            mAIView->mLifeBar->setDimensions(10*ratio,1);
            Ogre::Vector3 pos=mAIView->mLifeBar->getPosition();
            mAIView->mLifeBar->setColour(Ogre::ColourValue(255-ratio*10,ratio*10,0));
            
            if (mAIView->mCreature->mActualHealth<=0) {
                evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Muerto(mAIView->mCreature)));
                mAIView->mCreature->setState(Creature::DIE,false);
            }
        }
        

        else if (stricmp(evento.getType().getStr(),Evt_Muerto::gkName)==0)
         {
            
            if (mAIViewDragon->GetFSM()->isInState(*SeekingDragon::Instance()))
            {
              Evt_Muerto evt=dynamic_cast<Evt_Muerto &>(evento);
              Creature *criaturaMuerta=evt.mElemento;
              if (criaturaMuerta->getId()==mAIViewDragon->getTarget()->getId())
               {
                
                      mAIViewDragon->GetFSM()->ChangeState(SeekingDragon::Instance());
                      mAIViewDragon->target=0;
               }
            
                 
             }   
          }
	return false;
}