/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "AIViewListener.h"
#include "AIView.h"
#include "../Evt_Mover.h"

AIViewListener::AIViewListener(AIView * aiv)
{
	mAIView=aiv;
}

AIViewListener::~AIViewListener(void)
{
}

void AIViewListener::UpdateObstaclesPerception(std::vector<GameActor*> obstaclesVector)
{
    
   StaticActor *closestObstacle=0;
   StaticActor *actualObstacle=0;
   Ogre::Vector2 posObs;
   Ogre::Vector2 posCreature=Ogre::Vector2(mAIView->getCreature()->getPosition().x,mAIView->getCreature()->getPosition().z);
   double closestDistance=1000000;
   double actualDistance;
   while (!obstaclesVector.empty()) 
		 {

	             GameActor * actualActor=obstaclesVector.back();
                    
	             int tipo =actualActor->getType();
		     if (tipo==2)  //es obst�culo
			      {
				  if (!closestObstacle)
				        {
				          closestObstacle=static_cast<StaticActor*>(actualActor);
				          posObs=Ogre::Vector2(closestObstacle->getPosition().x,closestObstacle->getPosition().z);
					  closestDistance=posObs.squaredDistance(posCreature);
				
				         }
				   else
				       {
					   actualObstacle=static_cast<StaticActor*>(actualActor);
					   posObs=Ogre::Vector2(actualObstacle->getPosition().x,actualObstacle->getPosition().z);
					   actualDistance=posObs.squaredDistance(posCreature);
					   if (actualDistance<closestDistance)
					       {
						     closestDistance=actualDistance;
						     closestObstacle=actualObstacle;
					       }

				        }
			     }
			     else
			      {

			       }

			    obstaclesVector.pop_back();

		    }  
			//me quedo con el obstaculo m�s cercano a una distancia
		    if (closestObstacle)
			{
				if (closestDistance<(closestObstacle->getRadius()*20))
				{

				  mAIView->closestObstacle=closestObstacle;
				}
				else
				{
					mAIView->closestObstacle=0;
				}
			}
			else
			{
				mAIView->closestObstacle=0;
			}

	   }
