/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "AIViewSoldierListener.h"
#include "AIViewSoldier.h"
#include "AIView.h"
#include "../Evt_Mover.h"
#include "../Evt_Visto.h"
#include "../Creature.h"

AIViewSoldierListener::AIViewSoldierListener(AIViewSoldier * aiv) :AIViewListener(aiv)
{
	mAIViewSoldier=aiv;
}

AIViewSoldierListener::~AIViewSoldierListener(void)
{
}

bool AIViewSoldierListener::HandleEvent( GardeGames::Event & evento ) {

	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
         std::vector<GameActor*> obstaculosVistos;
	if (stricmp(evento.getType().getStr(),Evt_Visto::gkName)==0) 
	  { //si veo a alguien empiezo a vagar

		 Evt_Visto evt=dynamic_cast<Evt_Visto &>(evento);
		 if (evt.mCreature->getId()!=mAIView->getCreature()->getId()) 
		   { //si no es para nosotros nos vamos
			  return false;
		   }

                 
		 
		 while (!evt.mResultado.empty())
		 {
			  GameActor * actualActor=evt.mResultado.back();
			  int tipo =actualActor->getType();
			  if (tipo==1)//si no es un obstaculo 
			   {  
			  	  if (!mAIViewSoldier->GetFSM()->isInState(*SeekingSoldier::Instance()))
				      {
				         mAIViewSoldier->GetFSM()->ChangeState(SeekingSoldier::Instance());
					     mAIView->target=static_cast<Creature*>(actualActor);
					     //si no estaba huyendo que huya	
					     if (mAIViewSoldier->GetFSM()->isInState(*IdleSoldier::Instance()))
					       {
					  	       mAIViewSoldier->GetFSM()->ChangeState(SeekingSoldier::Instance());
					       }
				       }
			     }
			   else if (tipo==2)
                          {
                              obstaculosVistos.push_back(actualActor);
                          }
                          else
                          {
                              
                          }

			    evt.mResultado.pop_back();

		    }
                     //ACTUALIZAR LA PERCEPCIÓN DE OBSTACULOS 
                    UpdateObstaclesPerception(obstaculosVistos); 
		

	   }
	

	/*si un enemigo entra en mi radio de vision*/
	/*if (enemigo_cerca)
	 {
    	pDeer->GetFSM()->ChangeState(Wander::Instance());
	}*/
	

	return false;
}
