/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "AIViewWolf.h"
#include "AIViewWolfListener.h"
#include "../Evt_Mover.h"
#include "../Evt_Ver.h"
#include "../Evt_Visto.h"
#include "../Evt_Sonido.h"
#include "../Evt_Muerto.h"
#include "../Evt_Atacado.h"
#include "../Evt_QuitarJuego.h"
#include "SteeringBehaviors.h"

#include <fstream>
#include <iostream>
#include <string>
#include <algorithm>



using namespace std; 


AIViewWolf::AIViewWolf(Creature *creature, Ogre::Billboard* lifeBar)
	: AIView(creature,lifeBar)
{

	GardeGames::EventListenerPtr listener ( new AIViewWolfListener(this) ); //creamos su listener
	
	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();

	evtMgr->addListener( listener, GardeGames::EventType(Evt_Mover::gkName) ); //lo asociamos a eventos de movimiento
	evtMgr->addListener( listener, GardeGames::EventType(Evt_Ver::gkName) );
	//evtMgr->addListener( listener, GardeGames::EventType(Evt_Morir::gkName) );

	evtMgr->addListener( listener, GardeGames::EventType(Evt_Visto::gkName) );
         evtMgr->addListener( listener, GardeGames::EventType(Evt_Sonido::gkName) );
         evtMgr->addListener( listener, GardeGames::EventType(Evt_Muerto::gkName) );
         evtMgr->addListener( listener, GardeGames::EventType(Evt_Atacado::gkName) );
	//evtMgr->addListener( listener, GardeGames::EventType(Evt_Atacado::gkName) ); 

	

	//inicializar maquina de estad0s
     m_pStateMachine = new StateMachine<AIViewWolf>(this); 
      m_pStateMachine->SetCurrentState(WanderingWolf::Instance());
     m_pSteering=new SteeringBehaviors(this);
	 getSteeringBehaviors()->wanderOn();
}

AIViewWolf::~AIViewWolf(void)
{
	if(mCreature) {
		delete mCreature;
	}
}

SteeringBehaviors* AIViewWolf::getSteeringBehaviors()
{
	return this->m_pSteering;
}

void AIViewWolf::VOnUpdate(int deltaMilliseconds) 
{
	
    /*envio el evento de ver*/

    
        
    
	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
        
   if (!mCreature->isAlive() )
    {
	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_QuitarJuego(this,mCreature)));
        return;
    }
        
	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Ver(mCreature,100,15)));
	

	mCreature->update(deltaMilliseconds);


	timeSinceLastFrame=(double)deltaMilliseconds/1000;

	m_pStateMachine->Update();
	closestObstacle=0;
	//evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(mCreature,Ogre::Vector3(100,0,0))));

}


Ogre::Vector2 AIViewWolf::KinematicSeek()

{
	Ogre::Vector2 dv=Ogre::Vector2(-(target->getPosition().x-getCreature()->getPosition().x),target->getPosition().y-getCreature()->getPosition().z);
	   dv.normalise(); 
	   Ogre::Vector2 desiredVelocity =dv*getCreature()->getMaxSpeed();

	  double vx=desiredVelocity.x;
	  double vy=desiredVelocity.y;
	  Ogre::Vector2 vel;

       if (vx>=0)
		{
			vel.x=minimo(vx,mCreature->getMaxSpeed());
		}
		else
		{
			vel.x=maximo(vx,-mCreature->getMaxSpeed());
		}
       //
		if (vy>=0)
		{
			vel.y=minimo(vy,mCreature->getMaxSpeed());
		}
		else
		{
			vel.y=maximo(vy,-mCreature->getMaxSpeed());
		}


	
		//poner esa velocidad en el sistema de coordenadas

		return localVelocity(Ogre::Vector2(vel.x,vel.y),mCreature->getOrientation());
}

  