/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "SoldierOwnedStates.h"
#include "AIViewSoldier.h"
#include "Ogre.h"
#include "../Evt_Mover.h"


//--------------------------------------methods para Wandering

IdleSoldier* IdleSoldier::Instance()
{
  static IdleSoldier instance;

  return &instance;
}

void IdleSoldier::Enter(AIViewSoldier* pAIWiewSoldier)
{
	   
}


void IdleSoldier::Execute(AIViewSoldier* pAIWiewSoldier)
{  
	
	
}


void IdleSoldier::Exit(AIViewSoldier* pAIWiewSoldier)
{	
} 

//----------------------------------------metodos para Seeking

SeekingSoldier* SeekingSoldier::Instance()
{
  static SeekingSoldier instance;

  return &instance;
}


void SeekingSoldier::Enter(AIViewSoldier* pAIWiewSoldier)
{  
	pAIWiewSoldier->getSteeringBehaviors()->followPathOn();	
}


void SeekingSoldier::Execute(AIViewSoldier* pAIWiewSoldier)
{
        Ogre::Vector3 distance =pAIWiewSoldier->target->getPosition() - pAIWiewSoldier->_path.back();
        
        if (distance.length() > 2) {
            pAIWiewSoldier->goToLocation(pAIWiewSoldier->target->getPosition(),
                        pAIWiewSoldier->_navigationMesh->findCell(pAIWiewSoldier->target->getPosition()));
                         
            return;
        }

	//perseguimos al target
	Ogre::Vector2 velo=pAIWiewSoldier->addForce(pAIWiewSoldier->getSteeringBehaviors()->PrioritiesAlgorithm());

        GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();

	Ogre::Vector3 mov=Ogre::Vector3(velo.x,0,velo.y);

	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(pAIWiewSoldier->mCreature,mov)));
	
}


void SeekingSoldier::Exit(AIViewSoldier* pAIWiewSoldier)
{
		pAIWiewSoldier->getSteeringBehaviors()->followPathOff();

}
