/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "WolfOwnedStates.h"
#include "AIViewWolf.h"
#include "Ogre.h"
#include "../Evt_Mover.h"
#include "../Evt_Atacar.h"


//--------------------------------------methods for Wandering

WanderingWolf* WanderingWolf::Instance()
{
  static WanderingWolf instance;

  return &instance;
}

void WanderingWolf::Enter(AIViewWolf* pAIWiewWolf)
{
	pAIWiewWolf->getSteeringBehaviors()->wanderOn();	   
}


void WanderingWolf::Execute(AIViewWolf* pAIWiewWolf)
{  
	
      
	Ogre::Vector2 velocity=pAIWiewWolf->addForce(pAIWiewWolf->getSteeringBehaviors()->PrioritiesAlgorithm());

        GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
        
        Ogre::Vector3 mov(velocity.x/800,0,Ogre::Math::Abs(velocity.y)/2);

	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(pAIWiewWolf->mCreature,mov)));
}


void WanderingWolf::Exit(AIViewWolf* pAIWiewWolf)
{
	pAIWiewWolf->getSteeringBehaviors()->wanderOff();	
} 

//----------------------------------------methods for Seeking

Seeking* Seeking::Instance()
{
  static Seeking instance;

  return &instance;
}


void Seeking::Enter(AIViewWolf* pAIWiewWolf)
{  
	pAIWiewWolf->getSteeringBehaviors()->seekOn();	
}


void Seeking::Execute(AIViewWolf* pAIWiewWolf)
{
     //aumentamos el tiempo desde el ultimo ataque
    GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
    pAIWiewWolf-> setTimeSinceLastAttack(pAIWiewWolf->getTimeSinceLastAttack()+pAIWiewWolf->getTimeSinceLastFrame());
       
        
        
    if (!pAIWiewWolf->isAttacking())
      {
       //atacamos si podemos
       
         if (pAIWiewWolf->canAttack())
         {
                 
               pAIWiewWolf->Attacking=true;
               pAIWiewWolf->getCreature()->setState(Creature::ATTACK1,false);
          }
         
             //perseguimos al target
	   Ogre::Vector2 velo=pAIWiewWolf->addForce(pAIWiewWolf->getSteeringBehaviors()->PrioritiesAlgorithm());
	   Ogre::Vector3 mov=Ogre::Vector3(velo.x,0,velo.y);
	   evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(pAIWiewWolf->mCreature,mov)));
       
       }
    else
      {
        pAIWiewWolf->getCreature()->setState(Creature::ATTACK1,false);
        if (pAIWiewWolf->canDamage())
        {
            //lanzamos los eventos de ataque
            printf("\n canAttack");
            Ogre::Vector3 direccion=pAIWiewWolf->target->getPosition()-pAIWiewWolf->getCreature()->getPosition();
            evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Atacar(pAIWiewWolf->getCreature(),pAIWiewWolf->getCreature()->getAttack1(),direccion,2)));
            pAIWiewWolf-> setTimeSinceLastAttack(0);
            pAIWiewWolf->Attacking=false;
        }
     

      }
       

}


void Seeking::Exit(AIViewWolf* pAIWiewWolf)
{
		pAIWiewWolf->getSteeringBehaviors()->seekOff();
                pAIWiewWolf->timeSinceLastAttack=MIN_TIME_BETWEEN_ATTACKS;
}

//----------------------------------------methods for HelpingFriend

HelpingFriend* HelpingFriend::Instance()
{
  static HelpingFriend instance;

  return &instance;
}


void HelpingFriend::Enter(AIViewWolf* pAIWiewWolf)
{  
	pAIWiewWolf->getSteeringBehaviors()->arriveOn();	
}


void HelpingFriend::Execute(AIViewWolf* pAIWiewWolf)
{
    
        
        //si estamos muy cerca comenzamos a vagar
        Ogre::Vector3 actualPos=Ogre::Vector3(pAIWiewWolf->getCreature()->getPosition());
        
        if (pAIWiewWolf->getArrivingPoint().squaredDistance(actualPos)<3000)
            
        {
            
             pAIWiewWolf->GetFSM()->ChangeState(WanderingWolf::Instance());
        }
        else
        {


	//vamos hasta la posicion amigo
	Ogre::Vector2 velo=pAIWiewWolf->addForce(pAIWiewWolf->getSteeringBehaviors()->PrioritiesAlgorithm());

	 

	//Ogre::Vector2 velo=pAIWiewWolf->KinematicSeek();

       GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();

	Ogre::Vector3 mov=Ogre::Vector3(velo.x,0,velo.y);

	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(pAIWiewWolf->mCreature,mov)));
        }
	
}


void HelpingFriend::Exit(AIViewWolf* pAIWiewWolf)
{
		pAIWiewWolf->getSteeringBehaviors()->arriveOff();

}




