/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "State.h"
#include "SteeringBehaviors.h"


/**
 *  @author Hector Agustin Lana
 *  @date 14-01-2012
 *
 *  Estas clase modela los estados de un lobo
 *  
 */


class AIViewWolf;



class WanderingWolf : public State<AIViewWolf>
{
private:

	WanderingWolf(){}

  WanderingWolf(const WanderingWolf&);
  WanderingWolf& operator=(const WanderingWolf&);

public:

  
  static WanderingWolf* Instance();

  virtual void Enter(AIViewWolf* pAIWiewWolf);

  virtual void Execute(AIViewWolf* pAIWiewWolf);

  virtual void Exit(AIViewWolf* pAIWiewWolf);
};


//------------------------------------------------------------------------
//
//------------------------------------------------------------------------

class Seeking : public State<AIViewWolf>
{
private:
  
  Seeking(){}

  
  Seeking(const Seeking&);
  Seeking& operator=(const Seeking&);

public:


  static Seeking* Instance();

  virtual void Enter(AIViewWolf* pAIWiewWolf);

  virtual void Execute(AIViewWolf* pAIWiewWolf);

  virtual void Exit(AIViewWolf* pAIWiewWolf);
};


class HelpingFriend : public State<AIViewWolf>
{
private:
  
  HelpingFriend(){}

 
  HelpingFriend(const HelpingFriend&);
 HelpingFriend& operator=(const HelpingFriend&);

public:

 
  static HelpingFriend* Instance();

  virtual void Enter(AIViewWolf* pAIWiewWolf);

  virtual void Execute(AIViewWolf* pAIWiewWolf);

  virtual void Exit(AIViewWolf* pAIWiewWolf);
};