#include "GardeGames/GardeGames.h"
#include "EstadoJugando.h"




#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
#define WIN32_LEAN_AND_MEAN
#include "windows.h"
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR strCmdLine, INT ) {
#else
int main( int argc, char **argv ) {
#endif
	GardeGames::GameManagerEventManaged *gameManager = new GardeGames::GameManagerEventManaged();
	try {
		// Initialise the game and switch to the first state
		std::vector<GardeGames::GameState*> estados;
		estados.push_back(new EstadoJugando());
		//estados.push_back(new EstadoMenu());
		//estados.push_back(new EstadoFinal());
		gameManager->startGame(estados,"EstadoJugando");
	}
	catch ( Ogre::Exception& ex ) {
            printf("\n\n\n---EXCEPCION OGRE: %s\n\n\n\n\n\n\n\n\n",ex.getFullDescription());
            
                
		#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
				MessageBoxA( NULL, ex.getFullDescription().c_str(), "An exception has occurred!", MB_OK | MB_ICONERROR | MB_TASKMODAL );
		#else
				std::cerr << "An exception has occured: " << ex.getFullDescription();
		#endif

              

                                
	}
        catch ( std::exception& ex ) {
            printf("\n\n\n---EXCEPCION STD: %s\n\n\n\n\n\n\n\n\n",ex.what());
		#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
				MessageBoxA( NULL, ex.what(), "An exception has occurred!", MB_OK | MB_ICONERROR | MB_TASKMODAL );
		#else
				std::cerr << "An exception has occured: " << ex.what();
		#endif
               
	}
        catch ( exception& ex ) {
            printf("\n\n\n---EXCEPCION GENERICA: %s\n\n\n\n\n\n\n\n\n",ex.what());
		#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
				MessageBoxA( NULL, ex.what(), "An exception has occurred!", MB_OK | MB_ICONERROR | MB_TASKMODAL );
		#else
				std::cerr << "An exception has occured: " << ex.what();
		#endif
              
	}
        catch ( int ex ) {
            printf("\n\n\n---EXCEPCION INT: %d\n\n\n\n\n\n\n\n\n",ex);
		/*#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
				MessageBoxA( NULL, ex.what(), "An exception has occurred!", MB_OK | MB_ICONERROR | MB_TASKMODAL );
		#else
				std::cerr << "An exception has occured: " << ex.what();
		#endif*/
           
	}
        catch ( char* ex ) {
            printf("\n\n\n---EXCEPCION CHAR: %s\n\n\n\n\n\n\n\n\n",ex);
		/*#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
				MessageBoxA( NULL, ex.what(), "An exception has occurred!", MB_OK | MB_ICONERROR | MB_TASKMODAL );
		#else
				std::cerr << "An exception has occured: " << ex.what();
		#endif*/
            
	}
        catch ( ... ) {
            printf("\n\n\n---EXCEPCION ...: NI IDEA\n\n\n\n\n\n\n\n\n");
		/*#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
				MessageBoxA( NULL, ex.what(), "An exception has occurred!", MB_OK | MB_ICONERROR | MB_TASKMODAL );
		#else
				std::cerr << "An exception has occured: " << ex.what();
		#endif*/
            
	}
	delete gameManager;
	return 0;
}